[SPOJ]Robots on a grid

1124: Robots on a grid

Time Limit: 1 Sec  Memory Limit: 128 MB
Submit: 326  Solved: 56
[Submit][Status][Web Board]

Description

You have recently made a grid traversing robot that can finnd its way from the top left corner of a grid to the bottom right corner. However, you had forgotten all your AI programming skills, so you only programmed your robot to go rightwards and downwards (that's after all where the goal is). You have placed your robot on a grid with some obstacles, and you sit and observe. However, after a while you get tired of observing it getting stuck, and ask yourself How many paths are there from the start position to the goal position?", and \If there are none, could the robot have made it to the goal if it could walk upwards and leftwards?" So you decide to write a program that, given a grid of size n x n with some obstacles marked on it where the robot cannot walk, counts the di erent ways the robot could go from the top left corner s to the bottom right t, and if none, tests if it were possible if it could walk up and left as well. However, your program does not handle very large numbers, so the answer should be given modulo 2^31 - 1.

Input

On the fi rst line is one integer, 1 < n <= 1000. Then follows n lines, each with n characters, where each character is one of '.' and '#', where '.' is to be interpreted as a walkable tile and '#' as a non-walkable tile. There will never be a wall at s, and there will never be a wall at t.

Output

Output one line with the number of di erent paths starting in s and ending in t (modulo 2^31 - 1) or THE GAME IS A LIE if you cannot go from s to t going only rightwards and  downwards but you can if you are allowed to go left and up as well, or INCONCEIVABLE if  there simply is no path from s to t.

Sample Input

5
.....
#..#.
#..#.
...#.
.....

Sample Output

6

HINT

 

Source

NCPC 2011

//题目链接1 http://acdreamoj.sinaapp.com/problem.php?cid=1003&pid=4
//题目链接2 http://www.spoj.pl/problems/ROBOTGRI/
//本题是湖南师范大学月赛的一道题,也是NCPC 2011的一道题
//题目意思:查找从左上角走到右下角的路径数目(要求是只往右和下走)
/*解题思路:DP+BFS   一开始我图代码简单就用了DFS(没剪枝),结果无限RE..目测是递归太深
  之后果断换BFS,一次AC

  其实这题的思路还是DP占大部分的
  paths(x; y) = paths(x - 1; y) + paths(x; y - 1) 这一句是DP的关键所在,将路径条数状态转移!每个点都存一次走到该点的条数
  意思就是每一个点 都能从 它左边的点或者上面的点走过来 
  */
#include<stdio.h>
#include<iostream>
#include<string.h>
#include<math.h>
#include<queue>
using namespace std;
const int H = 0x7FFFFFFF;
const int MAX = 1100;
char map[MAX][MAX];
long long path[MAX][MAX];   //注意用 long long 或者 __int64
bool way[MAX][MAX];
int n;
int xx[4]={0,0,1,-1};
int yy[4]={1,-1,0,0};
struct node                 //以坐标形式入队
{
	int x,y;
	node(int a,int b)
	{
		x=a;
		y=b;
	}
};
queue<node> q;
void bfs()                 //BFS
{
	int i;
	while(!q.empty())
		q.pop();
	q.push(node(1,1));
	while(!q.empty())
	{
		if(q.front().x >= 1 && q.front().y >=1 && q.front().x <= n && q.front().y <= n)
		{
			for(i=0;i<4;i++)
			{
				if(map[q.front().x + xx[i] ][q.front().y + yy[i] ] == '.' && way[q.front().x + xx[i]][q.front().y + yy[i] ] == false)
				{
					way[q.front().x + xx[i]][q.front().y + yy[i] ] = true;
					q.push(node( q.front().x + xx[i],q.front().y + yy[i]) );
				}
			}
			q.pop();
		}else q.pop();
	}
}
int main()
{
	while(~scanf("%d",&n))
	{
		int i,j;
		memset(path,0,sizeof(path));
		path[1][1]=1;
		way[1][1]=true;
		for(i=1;i<=n;i++)
		{
			getchar();
			for(j=1;j<=n;j++)
			{
				scanf("%c",&map[i][j]);
				if(map[i][j]=='.' && (i!=1 || j!=1))
				{
					path[i][j] = (path[i-1][j]%H + path[i][j-1]%H) % H; //DP
				}
			}
		}
		bfs();
		if(way[n][n]==false)
			printf("INCONCEIVABLE\n");
		else if(path[n][n] == 0)
		{
			printf("THE GAME IS A LIE\n");
		}else 
			printf("%lld\n",path[n][n]%H);
	}
	return 0;
}



posted @ 2012-04-10 19:04  Felix_F  阅读(349)  评论(0编辑  收藏  举报